#include "buffer.h"
#include <stdio.h>
#include <assert.h>
#include <stdio.h>
#include <sys/resource.h>

static double ru() {
	rusage ru0;
	getrusage(RUSAGE_SELF,&ru0);
	return ru0.ru_utime.tv_sec + ru0.ru_utime.tv_usec/1000000.0;
	       ;
}


int main(void) {
	Buffer buffer;
	lbytenum_t used_bytes;
	lbytenum_t allocated_bytes;
	llinenum_t lines;
	
	for(unsigned i=0; i<54899*4; i+=3) {
//	for(unsigned i=0; i<123*2; i+=3) {
		buffer.appendLine();
		buffer.insert(i+0,0,"0123456789012345678901234567890123456789AB",42);
		buffer.appendLine();
		buffer.insert(i+1,0,"0123456789012345678901234567890123456789AB",42);
		buffer.appendLine();
		buffer.insert(i+2,0,"0123456789ab",12);
	}
/*
	buffer.queryStatistics(&used_bytes,&allocated_bytes,&lines);
	printf("used_bytes=%d  allocated_bytes=%d lines=%d\n",
	       used_bytes,allocated_bytes,lines);
*/
	for(unsigned i=buffer.queryLineCount(); i>2; i-=2) {
		buffer.removeLine(i);
	}
/*
	buffer.queryStatistics(&used_bytes,&allocated_bytes,&lines);
	printf("used_bytes=%d  allocated_bytes=%d lines=%d\n",
	       used_bytes,allocated_bytes,lines);
*/
	unsigned m=buffer.queryLineCount();
	for(unsigned i=0; i<m; i+=3) {
		buffer.appendLine();
		buffer.insert(i+0,0,"01234567890123456789xx",22);
		buffer.appendLine();
		buffer.insert(i+1,0,"01234567890123456789xxyy",24);
	}

	buffer.queryStatistics(&used_bytes,&allocated_bytes,&lines);
	printf("used_bytes=%d  allocated_bytes=%d lines=%d\n",
	       used_bytes,allocated_bytes,lines);
	double ru1=ru();
	buffer.compact();
	double ru2=ru();
	buffer.queryStatistics(&used_bytes,&allocated_bytes,&lines);
	printf("used_bytes=%d  allocated_bytes=%d lines=%d\n",
	       used_bytes,allocated_bytes,lines);
	printf("time spent compacting: %f\n",ru2-ru1);
	
	return 0;
}
